<?php declare(strict_types = 1);

namespace DoctrineMigrations;

use App\Migrations\MigrationBase;
use Doctrine\DBAL\Schema\Schema;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
class Version20180111205129 extends MigrationBase
{
  public function up(Schema $schema)
  {
    $this->ensureMySQL();

    // Translatable support.
    $sql = <<<SQL
CREATE TABLE ext_translations (
  id INT AUTO_INCREMENT NOT NULL, 
  locale VARCHAR(8) NOT NULL, 
  object_class VARCHAR(255) NOT NULL, 
  field VARCHAR(32) NOT NULL, 
  foreign_key VARCHAR(64) NOT NULL, 
  content LONGTEXT DEFAULT NULL, 

  INDEX translations_lookup_idx (locale, object_class, foreign_key), 
  UNIQUE INDEX lookup_unique_idx (locale, object_class, field, foreign_key), 
  PRIMARY KEY(id)
  ) 

  DEFAULT CHARACTER SET utf8 
  COLLATE utf8_unicode_ci 
  ENGINE = InnoDB
SQL;
    $this->addSql($sql);

    // Loggable support.
    $sql = <<<SQL
CREATE TABLE ext_log_entries (
  id INT AUTO_INCREMENT NOT NULL, 
  action VARCHAR(8) NOT NULL, 
  logged_at DATETIME NOT NULL, 
  object_id VARCHAR(64) DEFAULT NULL, 
  object_class VARCHAR(255) NOT NULL, 
  version INT NOT NULL, 
  data LONGTEXT DEFAULT NULL COMMENT '(DC2Type:array)', 
  username VARCHAR(255) DEFAULT NULL, 
  
  INDEX log_class_lookup_idx (object_class), 
  INDEX log_date_lookup_idx (logged_at), 
  INDEX log_user_lookup_idx (username), 
  INDEX log_version_lookup_idx (object_id, object_class, version), 
  PRIMARY KEY(id)
  ) 
  
  DEFAULT CHARACTER SET utf8 
  COLLATE utf8_unicode_ci 
  ENGINE = InnoDB
SQL;
    $this->addSql($sql);

    // Timestampable support.
    $sql = <<<SQL
ALTER TABLE product 
  ADD changed DATETIME NOT NULL, 
  ADD created DATETIME NOT NULL
SQL;
    $this->addSql($sql);
  }

  public function down(Schema $schema)
  {
    $this->ensureMySQL();
    $this->addSql('DROP TABLE ext_translations');
    $this->addSql('DROP TABLE ext_log_entries');
    $this->addSql('ALTER TABLE product DROP changed, DROP created');
  }
}
